unit f_htmllabel;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, ComCtrls, Buttons, rHTMLLabel, rImprovedComps,
  PropSaveMain;

type
  THTMLLabelForm = class(TForm)
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet3: TTabSheet;
    gb1: TGroupBox;
    lRes: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    rgIcon: TRadioGroup;
    rgBut: TRadioGroup;
    btShowDlg: TButton;
    btDlgQ: TButton;
    btDlgQ2: TButton;
    cb1: TComboBox;
    cb2: TComboBox;
    GroupBox2: TGroupBox;
    lIn: TLabel;
    Label7: TLabel;
    eInputStr: TEdit;
    btInputStr: TButton;
    btInputInt: TButton;
    btInputPsw: TButton;
    btShowInput: TButton;
    GroupBox3: TGroupBox;
    btShowErr2: TButton;
    btShowErr: TButton;
    btShowInfo: TButton;
    Label8: TLabel;
    GroupBox8: TGroupBox;
    lblTest: TrHTMLLabel;
    Memo: TMemo;
    Panel2: TPanel;
    Label13: TLabel;
    eP1: TEdit;
    TabSheet2: TTabSheet;
    GroupBox7: TGroupBox;
    lbURL1: TrURLLabel;
    lbURL2: TrURLLabel;
    FormatLabel6: TrHTMLLabel;
    FormatLabel7: TrHTMLLabel;
    lbURL3: TrURLLabel;
    FormatLabel8: TrHTMLLabel;
    lbURL4: TrURLLabel;
    FormatLabel9: TrHTMLLabel;
    TabSheet4: TTabSheet;
    Panel1: TPanel;
    FormatLabel1: TrHTMLLabel;
    FormatLabel2: TrHTMLLabel;
    FormatLabel4: TrHTMLLabel;
    FormatLabel3: TrHTMLLabel;
    lblFont: TrHTMLLabel;
    FormatLabel5: TrHTMLLabel;
    eNum: TEdit;
    btShowTip: TBitBtn;
    btShowInfoCenter: TButton;
    btShowTipEvent: TBitBtn;
    btDlgUserDef2: TButton;
    chWordWrap: TCheckBox;
    btShowInfoAbort: TButton;
    btShowInfoProgress: TButton;
    rHTMLLabel1: TrHTMLLabel;
    rHTMLLabel2: TrHTMLLabel;
    btDlgI2: TButton;
    btDlgI: TButton;
    btDlgW: TButton;
    btDlgE: TButton;
    rHTMLLabel3: TrHTMLLabel;
    btDlgUserDef3: TButton;
    procedure btDlgQClick(Sender: TObject);
    procedure btDlgQ2Click(Sender: TObject);
    procedure btInputStrClick(Sender: TObject);
    procedure btInputPswClick(Sender: TObject);
    procedure btShowInputClick(Sender: TObject);
    procedure btShowInfoClick(Sender: TObject);
    procedure btShowErrClick(Sender: TObject);
    procedure btShowErr2Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure lbURL4Click(Sender: TObject);
    procedure lblTestAnchorClick(Sender: TObject; LinkName: String);
    procedure lblTestGetParameter(Sender: TObject; var ParamStr: String);
    procedure eP1Change(Sender: TObject);
    procedure MemoChange(Sender: TObject);
    procedure btShowDlgClick(Sender: TObject);
    procedure btInputIntClick(Sender: TObject);
    procedure btShowTipClick(Sender: TObject);
    procedure TipAbort(Sender: TObject);
    procedure btShowInfoCenterClick(Sender: TObject);
    procedure btShowTipEventClick(Sender: TObject);
    procedure btDlgUserDef2Click(Sender: TObject);
    procedure btShowInfoAbortClick(Sender: TObject);
    procedure btShowInfoProgressClick(Sender: TObject);
    procedure btDlgIClick(Sender: TObject);
    procedure btDlgI2Click(Sender: TObject);
    procedure btDlgWClick(Sender: TObject);
    procedure btDlgEClick(Sender: TObject);
    procedure btDlgUserDef3Click(Sender: TObject);
  private
    { Private declarations }
    Aborted: boolean;
    procedure ProcClick(Sender: TObject; LinkName: string);
  public
    { Public declarations }
  end;

var
  HTMLLabelForm: THTMLLabelForm;

implementation

{$R *.dfm}
uses RosiCompGlobalCfg, rdlg, rtool, rstring, rtip;

procedure THTMLLabelForm.FormCreate(Sender: TObject);
begin
  lblTest.CaptionStrings.Assign(Memo.Lines);
  lbURL3.URLCommand:='file:' + GetAppDir + 'test.txt';
  RosiCompGlobalCfg.RosiCompConfig.rDBToolCfg.rDlg_AnchorClick:=ProcClick;
end;

procedure THTMLLabelForm.btShowDlgClick(Sender: TObject);
begin
  lRes.Caption:=IntToStr(ShowDlg(TDialogType(rgIcon.ItemIndex), TButtonsType(rgBut.ItemIndex), [cb1.Text, cb2.Text], self.chWordWrap.Checked));
end;

procedure THTMLLabelForm.btDlgQClick(Sender: TObject);
begin
  lRes.Caption:=IntToStr(DlgQ(cb1.Text, self.chWordWrap.Checked));
end;

procedure THTMLLabelForm.btDlgQ2Click(Sender: TObject);
begin
  lRes.Caption:=IntToStr(DlgQ2(cb1.Text, cb2.Text, self.chWordWrap.Checked));
end;

procedure THTMLLabelForm.btDlgUserDef2Click(Sender: TObject);
begin
  lRes.Caption:=IntToStr(DlgQUserDef('Any long long text for button 1', 'Any text for button 2', '', [cb1.Text, cb2.Text]));
end;

procedure THTMLLabelForm.btDlgUserDef3Click(Sender: TObject);
begin
  lRes.Caption:=IntToStr(DlgQUserDef('Any long long text for button 1', 'Any text for button 2', 'Short text button 3', [cb1.Text, cb2.Text]));
end;

procedure THTMLLabelForm.btDlgWClick(Sender: TObject);
begin
  DlgW(cb1.Text, self.chWordWrap.Checked);
end;

procedure THTMLLabelForm.btInputStrClick(Sender: TObject);
var
  s: string;
begin
  s:=eInputStr.Text;
  if InputStr('Caption', cb1.Text, s) then
    eInputStr.Text:=s;
end;

procedure THTMLLabelForm.btInputPswClick(Sender: TObject);
var
  s: string;
begin
  s:='';
  if InputPassword('Caption', s) then
    eInputStr.Text:=s;
end;

procedure THTMLLabelForm.btInputIntClick(Sender: TObject);
var
  i: integer;
begin
  try
    i:=StrToInt(eNum.Text);
  except
    i:=0;
  end;
  if InputInt('', cb1.Text, i) then
    eNum.Text:=IntToStr(i);
end;

procedure THTMLLabelForm.btShowInputClick(Sender: TObject);
var
  s: string;
begin
  s:=eInputStr.Text;
  if ShowInput('Caption', cb1.Text, s, 500, #0) then
    eInputStr.Text:=s;
end;

procedure THTMLLabelForm.btShowErrClick(Sender: TObject);
begin
  try
    DlgI(IntToStr(1 div Random(1))); ;
  except
    on E: Exception do
      ShowErr('', E, false);
  end;
end;

procedure THTMLLabelForm.btShowErr2Click(Sender: TObject);
begin
  try
    DlgI(IntToStr(1 div Random(1))); ;
  except
    on E: Exception do
      ShowErr('<B>Unexpected error occured, calculation aborted</B>.<br>Contact <A name=TechSupport>technical support</A>.', E, false);
  end;
end;

procedure THTMLLabelForm.lbURL4Click(Sender: TObject);
begin
  DlgI('Clicked');
end;

procedure THTMLLabelForm.lblTestAnchorClick(Sender: TObject; LinkName: String);
begin
  DlgI('Click on link named: ' + LinkName);
end;

procedure THTMLLabelForm.lblTestGetParameter(Sender: TObject; var ParamStr: String);
begin
  if ParamStr = 'P1' then
    ParamStr:=eP1.Text;
end;

procedure THTMLLabelForm.eP1Change(Sender: TObject);
begin
  lblTest.Invalidate;
end;

procedure THTMLLabelForm.MemoChange(Sender: TObject);
begin
  lblTest.CaptionStrings.Assign(Memo.Lines);
  lblTest.Invalidate;
end;

procedure THTMLLabelForm.ProcClick(Sender: TObject; LinkName: string);
begin
  DlgI('User click to link in dialog.<BR>Link name: ' + LinkName);
end;

procedure THTMLLabelForm.btShowTipClick(Sender: TObject);
begin
  ShowTip(cb1.Text, '', nil);
end;

procedure THTMLLabelForm.btShowTipEventClick(Sender: TObject);
begin
  ShowTipEx('any text... test link: <A NAME=test_link>any link</A>', '', nil, ProcClick, false);
end;

procedure THTMLLabelForm.btDlgEClick(Sender: TObject);
begin
  DlgE(cb1.Text, self.chWordWrap.Checked);
end;

procedure THTMLLabelForm.btDlgI2Click(Sender: TObject);
begin
  DlgI2(cb1.Text, cb2.Text, self.chWordWrap.Checked);
end;

procedure THTMLLabelForm.btDlgIClick(Sender: TObject);
begin
  DlgI(cb1.Text, self.chWordWrap.Checked);
end;

procedure THTMLLabelForm.btShowInfoClick(Sender: TObject);
begin
  ShowInfo('Loading...' + #13 + 'Please wait.');
  Sleep(2000);
  ShowInfo('');
end;

procedure THTMLLabelForm.btShowInfoCenterClick(Sender: TObject);
begin
  ShowInfo('Window centered in any window component.', gb1);
  Sleep(2000);
  ShowInfo('');
end;

procedure THTMLLabelForm.btShowInfoAbortClick(Sender: TObject);
var
  i: integer;
begin
  Aborted:=false;
  i:=0;
  ShowInfoEx('Loading...', nil, TipAbort);
  repeat
    Sleep(10);
    Application.ProcessMessages;
    Inc(i);
    if Aborted then
    begin
      DlgW('Operation aborted');
      Break;
    end;
  until i > 500;
  ShowInfo('');
end;

procedure THTMLLabelForm.btShowInfoProgressClick(Sender: TObject);
var
  i: integer;
begin
  Aborted:=false;
  i:=0;
  repeat
    ShowInfoProgressBar('Loading...', nil, TipAbort, Round(100*i/500));
    Sleep(10);
    Application.ProcessMessages;
    Inc(i);
    if Aborted then
    begin
      DlgW('Operation aborted');
      Break;
    end;
  until i > 500;
  ShowInfo('');
end;

procedure THTMLLabelForm.TipAbort(Sender: TObject);
begin
  Aborted:=true;
end;

end.
