unit f_rdbgrid4;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls, PropSaveMain, PropSaveGrids, DB, Grids,
  DBGrids, rDBGrid, DBCtrls, rHTMLLabel;

type
  TrDBGrid4 = class(TForm)
    DBNavigator1: TDBNavigator;
    gr4: TrDBGrid;
    lblInfo: TrHTMLLabel;
    GroupBox1: TGroupBox;
    Label13: TLabel;
    clActiveRow: TColorBox;
    Image1: TImage;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    PropSaveMain1: TPropSaveMain;
    rDBGridsPropSave1: TrDBGridsPropSave;
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure lblInfoAnchorClick(Sender: TObject; LinkName: String);
    procedure rbFocus1Click(Sender: TObject);
    procedure gr4GetCellParams(Sender: TObject; Field: TField; AFont: TFont; var Background: TColor; ActiveRow, Highlight: Boolean);
    procedure gr4DrawColumnCellEnd(Sender: TObject; const Rect: TRect; DataCol: Integer; Column: TColumn; State: TGridDrawState);
    procedure gr4GetCellParamsEx(Sender: TObject; Field: TField; AFont: TFont; var Background: TColor; var DataImageDef: TDataImageDef;
      ActiveRow, Highlight: Boolean);
  private
  public
  end;

var
  rDBGrid4: TrDBGrid4;

implementation

uses dm_data, f_main, rDBGrid_DTEdit, rdlg;
{$R *.dfm}

procedure TrDBGrid4.FormShow(Sender: TObject);
begin
  DMData.qProducts.Close;
  DMData.qProducts.Open;
  gr4.Resort;
end;

procedure TrDBGrid4.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  DMData.qProducts.Close;
end;

procedure TrDBGrid4.lblInfoAnchorClick(Sender: TObject; LinkName: String);
begin
  ShowrDBGridEditor(gr4);
  gr4.Invalidate;
end;

procedure TrDBGrid4.rbFocus1Click(Sender: TObject);
begin
  // refresh all grid
  gr4.Invalidate;
end;

procedure TrDBGrid4.gr4GetCellParams(Sender: TObject; Field: TField; AFont: TFont; var Background: TColor; ActiveRow, Highlight: Boolean);
begin
  // change font for missing items
  if ((Field = DMData.qProductsUnitsInStock) or (Field = DMData.qProductsUnitsOnOrder)) and
    (DMData.qProductsUnitsInStock.AsFloat < DMData.qProductsUnitsOnOrder.AsFloat) then
  begin
    AFont.Color:=clRed;
    AFont.Style:=AFont.Style + [fsBold];
  end;

  // change background for discontinued
  if DMData.qProductsDiscontinued.DataType = ftBoolean then
  begin
    if (DMData.qProductsDiscontinued.AsBoolean) then
      Background:=clSilver;
  end
  else
    if (DMData.qProductsDiscontinued.AsInteger = 1) then
      Background:=clSilver;

  if Highlight then
  begin
    // set font and color for selected cell
    AFont.Style:=AFont.Style + [fsBold];
  end
  else
    if ActiveRow then
    begin
      // color all active row
      Background:=clActiveRow.Selected;
      // font as complement color (can be changed)
      AFont.Color:=Background xor $FFFFFF;
    end;
end;

procedure TrDBGrid4.gr4GetCellParamsEx(Sender: TObject; Field: TField; AFont: TFont; var Background: TColor; var DataImageDef: TDataImageDef;
  ActiveRow, Highlight: Boolean);
begin
  if (Field = DMData.qProductsUnitsInStock) then
  begin
    if Field.AsInteger < 20 then
    begin
      DataImageDef.UseDataImage:=true;
      DataImageDef.ImageIndex:=2;
      DataImageDef.ShowText:='+';
      DataImageDef.ImageAlignment:='L';
    end;
  end;
end;

procedure TrDBGrid4.gr4DrawColumnCellEnd(Sender: TObject; const Rect: TRect; DataCol: Integer; Column: TColumn; State: TGridDrawState);
begin
  // draw graphic for all records with discount
  if SameText(Column.FieldName, 'Flag') then
    if (DMData.qProductsUnitsInStock.AsFloat < DMData.qProductsReorderLevel.AsFloat) then
      gr4.DrawBMPInCell(Rect, Image1.Picture.Bitmap);
end;

end.
