unit f_rdbstringgrided;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, PropSaveMain, DB, DBCtrls, StdCtrls, ExtCtrls, Grids,
  rDBRecView, rImprovedComps, rDBComponents, rHTMLLabel, PropSaveGrids,
  rStringGridEd, rDBStringGridEd, ComCtrls;

type
  TrDBStringGridEdTest = class(TForm)
    PropSaveMain1: TPropSaveMain;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    GroupBox7: TGroupBox;
    btLoadData1: TButton;
    sg1: TrDBStringGridEd;
    btSaveData1: TButton;
    chAddNewRow1: TCheckBox;
    btDefCol1: TButton;
    sg2: TrDBStringGridEd;
    GroupBox1: TGroupBox;
    btLoadData2: TButton;
    btSaveData2: TButton;
    btLoadRows2: TButton;
    TabSheet3: TTabSheet;
    GroupBox2: TGroupBox;
    btLoadData3: TButton;
    btSaveData3: TButton;
    btLoadRows3: TButton;
    sg3: TrDBStringGridEd;
    lblInfo2: TrHTMLLabel;
    lblInfo3: TrHTMLLabel;
    lblInfo1: TrHTMLLabel;
    btPrint: TButton;
    btPrintDirect: TButton;
    TabSheet4: TTabSheet;
    sg4: TrDBStringGridEd;
    rHTMLLabel1: TrHTMLLabel;
    GroupBox3: TGroupBox;
    btLoadData4: TButton;
    btSaveData4: TButton;
    btAddRec4: TButton;
    procedure btLoadData1Click(Sender: TObject);
    procedure chAddNewRow1Click(Sender: TObject);
    procedure sg1FinishCellEditing(Sender: TObject; Col, Row: Integer);
    procedure btSaveData1Click(Sender: TObject);
    procedure btDefCol1Click(Sender: TObject);
    procedure btLoadRows2Click(Sender: TObject);
    procedure btLoadData2Click(Sender: TObject);
    procedure btSaveData2Click(Sender: TObject);
    procedure sg2FinishCellEditing(Sender: TObject; Col, Row: Integer);
    procedure btLoadRows3Click(Sender: TObject);
    procedure btLoadData3Click(Sender: TObject);
    procedure sg3FinishCellEditing(Sender: TObject; Col, Row: Integer);
    procedure btSaveData3Click(Sender: TObject);
    procedure btPrintClick(Sender: TObject);
    procedure btPrintDirectClick(Sender: TObject);
    procedure btLoadData4Click(Sender: TObject);
    procedure btSaveData4Click(Sender: TObject);
    procedure sg4FinishCellEditing(Sender: TObject; Col, Row: Integer);
    procedure btAddRec4Click(Sender: TObject);
  private
  public
  end;

var
  rDBStringGridEdTest: TrDBStringGridEdTest;

implementation

uses dm_data, f_main;
{$R *.dfm}

procedure TrDBStringGridEdTest.sg1FinishCellEditing(Sender: TObject; Col, Row: Integer);
begin
  btSaveData1.Enabled:=true;
end;

procedure TrDBStringGridEdTest.sg2FinishCellEditing(Sender: TObject; Col, Row: Integer);
begin
  btSaveData2.Enabled:=true;
end;

procedure TrDBStringGridEdTest.sg3FinishCellEditing(Sender: TObject; Col, Row: Integer);
begin
  btSaveData3.Enabled:=true;
end;

procedure TrDBStringGridEdTest.sg4FinishCellEditing(Sender: TObject; Col,
  Row: Integer);
begin
  btSaveData4.Enabled:=true;
end;

procedure TrDBStringGridEdTest.btDefCol1Click(Sender: TObject);
var
  c: Integer;
begin
  DMData.qEmp.Close;
  DMData.qEmp.Open;
  sg1.CreateTableColumns(true, true);
  // set custom type for NotesRTF
  for c := 0 to sg1.Columns.Count - 1 do
    if SameText(sg1.Columns[c].FieldName, 'NotesRTF') then
      sg1.Columns[c].ButtonStyle:=sgbRichText;
end;

procedure TrDBStringGridEdTest.btLoadData1Click(Sender: TObject);
begin
  sg1.LoadTableRows;
  self.btSaveData1.Enabled:=false;
end;

procedure TrDBStringGridEdTest.btSaveData1Click(Sender: TObject);
begin
  sg1.SaveTableRows;
  btLoadData1.Click;
end;

procedure TrDBStringGridEdTest.chAddNewRow1Click(Sender: TObject);
begin
  sg1.AutoAddNewRow:=self.chAddNewRow1.Checked;
end;

procedure TrDBStringGridEdTest.btLoadRows2Click(Sender: TObject);
begin
  DMData.qValDef.Close;
  DMData.qValDef.Open;
  sg2.LoadTableRows;
end;

procedure TrDBStringGridEdTest.btLoadData2Click(Sender: TObject);
begin
  DMData.qMatValues.Close;
  DMData.qMatValues.Open;
  sg2.LoadTableData(DMData.qMatValues, DMData.qMatValuesValueID, 1, true);
  btSaveData2.Enabled:=false;
end;

procedure TrDBStringGridEdTest.btSaveData2Click(Sender: TObject);
begin
  sg2.SaveTableData(DMData.qMatValues, DMData.qMatValuesValueID, 1, true);
  btLoadData2.Click;
end;

procedure TrDBStringGridEdTest.btLoadRows3Click(Sender: TObject);
begin
  DMData.qValDef.Close;
  DMData.qValDef.Open;
  sg3.LoadTableRows;
  DMData.qTemperatures.Close;
  DMData.qTemperatures.Open;
  sg3.LoadPivotColumn(DMData.qTemperatures, DMData.qTemperaturesTemperature, DMData.qTemperaturesTemperature, sg3.FixedCols, 1);
end;

procedure TrDBStringGridEdTest.btLoadData3Click(Sender: TObject);
begin
  DMData.qTempValues.Close;
  DMData.qTempValues.Open;
  sg3.LoadPivotData(DMData.qTempValues, DMData.qTempValuesValueID, DMData.qTempValuesTemperature, DMData.qTempValuesNumValue, 1, true);
  btSaveData3.Enabled:=false;
end;

procedure TrDBStringGridEdTest.btSaveData3Click(Sender: TObject);
begin
  sg3.SavePivotData(DMData.qTempValues, DMData.qTempValuesValueID, DMData.qTempValuesTemperature, DMData.qTempValuesNumValue, 1, true);
  btLoadData3.Click;
end;

procedure TrDBStringGridEdTest.btSaveData4Click(Sender: TObject);
begin
  sg4.SaveTableMultiRows(true);
end;

procedure TrDBStringGridEdTest.btLoadData4Click(Sender: TObject);
begin
  DMData.qEmp.Close;
  DMData.qEmp.Open;
  sg4.LoadTableMultiRows();
  btSaveData4.Enabled:=false;
end;

procedure TrDBStringGridEdTest.btAddRec4Click(Sender: TObject);
begin
  sg4.AddNewRecMultiRows(false, true);
end;

procedure TrDBStringGridEdTest.btPrintClick(Sender: TObject);
begin
  ShowMessage('Rosi DB Dialogs and Actions is needed for this function.');
//  rDBPrint.DBPrint(sg1, 'Title');
end;

procedure TrDBStringGridEdTest.btPrintDirectClick(Sender: TObject);
begin
  ShowMessage('Rosi DB Dialogs and Actions is needed for this function.');
//  rDBPrintDirect.DBPrintDirect(sg1, 'Title');
end;

end.
