unit f_main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, StdCtrls, Mask, Buttons, PropSaveMain, ImgList, db,
  rHTMLLabel, ExtCtrls, rHintWindow, RosiCompGlobalCfg;

const
  Ver = '15.4';
  sDBFile = 'DB file: ';

type
  TMain = class(TForm)
    SBar: TStatusBar;
    PSFile: TPropSaveFile;
    GridImg: TImageList;
    PropSaveMain1: TPropSaveMain;
    Timer1: TTimer;
    rHTMLLabel1: TrHTMLLabel;
    Label1: TLabel;
    rHTMLLabel2: TrHTMLLabel;
    GroupBox1: TGroupBox;
    FormatLabel1: TrHTMLLabel;
    bt1: TButton;
    bt2: TButton;
    bt4: TButton;
    bt3: TButton;
    bt5: TButton;
    btMS: TButton;
    GroupBox2: TGroupBox;
    FormatLabel2: TrHTMLLabel;
    btAct: TButton;
    GroupBox3: TGroupBox;
    FormatLabel3: TrHTMLLabel;
    bt21: TButton;
    bt22: TButton;
    btExp: TButton;
    bt23: TButton;
    bt24: TButton;
    btRep: TButton;
    bt25: TButton;
    GroupBox4: TGroupBox;
    FormatLabel24: TrHTMLLabel;
    FormatLabel25: TrHTMLLabel;
    chHelp: TCheckBox;
    rHTMLHint1: TrHTMLHint;
    bt6: TButton;
    btEvents: TButton;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure chHelpClick(Sender: TObject);
    procedure FormatLabel24AnchorClick(Sender: TObject; LinkName: String);
    procedure bt1Click(Sender: TObject);
    procedure bt2Click(Sender: TObject);
    procedure bt4Click(Sender: TObject);
    procedure bt3Click(Sender: TObject);
    procedure bt5Click(Sender: TObject);
    procedure btActClick(Sender: TObject);
    procedure bt21Click(Sender: TObject);
    procedure bt22Click(Sender: TObject);
    procedure btExpClick(Sender: TObject);
    procedure btMSClick(Sender: TObject);
    procedure bt23Click(Sender: TObject);
    procedure bt24Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure btRepClick(Sender: TObject);
    procedure bt25Click(Sender: TObject);
    procedure bt6Click(Sender: TObject);
    procedure btEventsClick(Sender: TObject);
  private
    { Private declarations }
    procedure OnHlp(Form: TForm; HelpContext: integer);
    procedure CheckExit(Sender: TObject; Field: TField; var CanExit: boolean);
    procedure RosiCompGeneralEvent(Sender: TObject; EventID: integer; Param1: TObject; Param2: TObject; var Value: Variant);
  public
    { Public declarations }
  end;

var
  Main: TMain;

implementation

{$R *.dfm}
uses rstring, rdlg, rtool, rdbtool, rDBGrid, dm_data, f_startup,
  f_rdbgrid1, f_rdbgrid2, f_rdbgrid3, f_rdbgrid4, f_rdbgrid5, f_rdbgrid_dbactions,
  f_rdbcomps, f_exportcomps, f_rdbgrid_ms, f_rdbrecview, f_rdbcheckbox,
  f_rdbtreeview, rDBComponents, rDBPrint, f_reportcomps,
  f_rdbstringgrided, f_rdbgrid6
  //rDBPrintDirect
  , f_rdbgridevents;


procedure TMain.FormCreate(Sender: TObject);
begin
  ShowStartUpInfo(sConnecting);
  Main.SBar.SimpleText:=sDBFile + DMData.DBConnect;
  ForceDirectories(GetAppDir + 'Output');
  RosiCompConfig.rDBPrintCfg.PrintData_Dir:=GetAppDir + 'Output';
  RosiCompConfig.rDBFilterCfg.ShowCaseSensitive:=false;
  RosiCompConfig.rDBFilterCfg.HideFieldNames:=true;
  RosiCompConfig.rDBComponentsCfg.ExitControlEvent:=CheckExit;
  RosiCompConfig.rDBGridPropsCfg.HideTitleGroups:=RosiCompConfig_On;

//  rGlyphs.MinScaleRatioWhenResized:=2;
  RosiCompConfig.Global_OnRosiCompGeneralEvent:=RosiCompGeneralEvent;

//  RosiCompConfig.rDBFilterCfg.FieldQuoteStart:=' ';
//  RosiCompConfig.rDBFilterCfg.FieldQuoteStop:=' ';
//  RosiCompConfig.rDBFilterCfg.TableQuoteStart:=' ';
//  RosiCompConfig.rDBFilterCfg.TableQuoteStop:=' ';

  ReportMemoryLeaksOnShutdown:=True;
end;

procedure TMain.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  DMData.DBDisConnect;
end;

procedure TMain.FormActivate(Sender: TObject);
begin
  ShowStartUpInfo('');
end;

procedure TMain.RosiCompGeneralEvent(Sender: TObject; EventID: Integer; Param1: TObject; Param2: TObject; var Value: Variant);
begin
  if EventID=rDBForms_FormShowEventID then
 //   if Sender is rDBPrintDirect.TrDBPrintDirectForm then
    begin
//      TrDBPrintDirectForm(Sender).chUseColors.Checked:=true;

    end;
end;

// ==============================================================
// page Other actions
procedure TMain.FormatLabel24AnchorClick(Sender: TObject; LinkName: String);
begin
  PSFile.Clear;
  PSFile.SaveFile('');
  PSFile.DisableAll:=true;
  ShowMessage('Close the application and run again with default values.');
end;

procedure TMain.chHelpClick(Sender: TObject);
begin
  if chHelp.Checked then
    RosiCompConfig.Global_ProcOnHelp:=OnHlp
  else
    RosiCompConfig.Global_ProcOnHelp:=nil;
end;

procedure TMain.OnHlp(Form: TForm; HelpContext: integer);
begin
  DlgI('Show any help for form: ' + Form.Name + ', HelpContext: ' + IntToStr(HelpContext));
end;

procedure TMain.CheckExit(Sender: TObject; Field: TField; var CanExit: boolean);
begin
  ShowMessage('Enter any value for field '+Field.DisplayLabel);
  CanExit:=false;
end;

procedure TMain.Timer1Timer(Sender: TObject);
begin
  Timer1.Enabled:=false;
//  Application.CreateForm(TCompImg, CompImg);
//  CompImg.ShowModal;
//  CompImg.Free;
  btEventsClick(nil);
  Close;
end;

procedure TMain.bt1Click(Sender: TObject);
begin
  Application.CreateForm(TrDBGrid1, rDBGrid1);
  rDBGrid1.ShowModal;
  rDBGrid1.Free;
end;

procedure TMain.bt2Click(Sender: TObject);
begin
  Application.CreateForm(TrDBGrid2, rDBGrid2);
  rDBGrid2.ShowModal;
  rDBGrid2.Free;
end;

procedure TMain.bt4Click(Sender: TObject);
begin
  Application.CreateForm(TrDBGrid3, rDBGrid3);
  rDBGrid3.ShowModal;
  rDBGrid3.Free;
end;

procedure TMain.bt3Click(Sender: TObject);
begin
  Application.CreateForm(TrDBGrid4, rDBGrid4);
  rDBGrid4.ShowModal;
  rDBGrid4.Free;
end;

procedure TMain.bt5Click(Sender: TObject);
begin
  Application.CreateForm(TrDBGrid5, rDBGrid5);
  rDBGrid5.ShowModal;
  rDBGrid5.Free;
end;

procedure TMain.bt6Click(Sender: TObject);
begin
  Application.CreateForm(TrDBGrid6, rDBGrid6);
  rDBGrid6.ShowModal;
  rDBGrid6.Free;
end;

procedure TMain.btMSClick(Sender: TObject);
begin
  Application.CreateForm(TrDBGridMS, rDBGridMS);
  rDBGridMS.ShowModal;
  rDBGridMS.Free;
end;

procedure TMain.btActClick(Sender: TObject);
begin
  Application.CreateForm(TrDBGrid_DBActions, rDBGrid_DBActions);
  rDBGrid_DBActions.ShowModal;
  rDBGrid_DBActions.Free;
end;

procedure TMain.bt21Click(Sender: TObject);
begin
  Application.CreateForm(TrDBComps, rDBComps);
  rDBComps.ShowModal;
  rDBComps.Free;
end;

procedure TMain.bt22Click(Sender: TObject);
begin
  Application.CreateForm(TrDBRecViewTest, rDBRecViewTest);
  rDBRecViewTest.ShowModal;
  rDBRecViewTest.Free;
end;

procedure TMain.bt23Click(Sender: TObject);
begin
  Application.CreateForm(TDBrCheckBox, DBrCheckBox);
  DBrCheckBox.ShowModal;
  DBrCheckBox.Free;
end;

procedure TMain.bt24Click(Sender: TObject);
begin
  Application.CreateForm(TrDBTreeViewTest, rDBTreeViewTest);
  rDBTreeViewTest.ShowModal;
  rDBTreeViewTest.Free;
end;

procedure TMain.bt25Click(Sender: TObject);
begin
  Application.CreateForm(TrDBStringGridEdTest, rDBStringGridEdTest);
  rDBStringGridEdTest.ShowModal;
  rDBStringGridEdTest.Free;
end;

procedure TMain.btEventsClick(Sender: TObject);
begin
  Application.CreateForm(TrDBGridEvents, rDBGridEvents);
  rDBGridEvents.ShowModal;
  rDBGridEvents.Free;
end;

procedure TMain.btExpClick(Sender: TObject);
begin
  Application.CreateForm(TExportComps, ExportComps);
  ExportComps.ShowModal;
  ExportComps.Free;
end;

procedure TMain.btRepClick(Sender: TObject);
begin
  Application.CreateForm(TReportComps, ReportComps);
  ReportComps.ShowModal;
  ReportComps.Free;
end;

end.
