unit f_rdbgridevents;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls, PropSaveMain, PropSaveGrids, DB, Grids,
  DBGrids, rDBGrid, DBCtrls, rHTMLLabel, StrUtils, rImprovedComps;

type
  TrDBGridEvents = class(TForm)
    DBNavigator1: TDBNavigator;
    gr: TrDBGrid;
    lblInfo: TrHTMLLabel;
    GroupBox1: TGroupBox;
    PropSaveMain1: TPropSaveMain;
    rDBGridsPropSave1: TrDBGridsPropSave;
    chStockLevelStatusBar: TCheckBox;
    chStockLevelDataImage: TCheckBox;
    chUnitsRedColor: TCheckBox;
    Label1: TLabel;
    eUnitsLimit: TrEditNum;
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure lblInfoAnchorClick(Sender: TObject; LinkName: String);
    procedure grGeneralEvent(Sender: TObject; EventType: TGeneralEventType; var EventParam: TGeneralEventRec; var ContinueEvent: Boolean);
    procedure chStockLevelStatusBarClick(Sender: TObject);
  private
  public
  end;

var
  rDBGridEvents: TrDBGridEvents;

implementation

uses dm_data, f_main, rDBGrid_DTEdit, RosiCompGlobalCfg, rdlg;
{$R *.dfm}

procedure TrDBGridEvents.FormShow(Sender: TObject);
begin
  DMData.qProducts.Close;
  DMData.qProducts.Open;
  gr.Resort;
end;

procedure TrDBGridEvents.chStockLevelStatusBarClick(Sender: TObject);
begin
  gr.Invalidate;
end;

procedure TrDBGridEvents.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  DMData.qProducts.Close;
end;

procedure TrDBGridEvents.lblInfoAnchorClick(Sender: TObject; LinkName: String);
begin
  ShowrDBGridEditor(gr);
  gr.Invalidate;
end;

procedure TrDBGridEvents.grGeneralEvent(Sender: TObject; EventType: TGeneralEventType; var EventParam: TGeneralEventRec; var ContinueEvent: Boolean);
begin
  case EventType of
    geChangeScaleBefore:
      ;
    geChangeScaleAfter:
      ;
    geIsBool:
      ;
    geIsMemo:
      ;
    geIsMemoGlyph:
      ;
    geIsMemoText:
      ;
    geIsGraphic:
      ;
    geIsFieldAsDate:
      ;
    geIsDate:
      ;
    geIsColor:
      ;
    geIsLink:
      ;
    geIsPassword:
      ;
    geIsFilter:
      ;
    geIsDrawDropDown:
      ;
    geIsDataBar:
      begin
        if EventParam.Field = DMData.qProductsUnitPrice then
          EventParam.ParamValue:=true;
        if EventParam.Field = DMData.qProductsUnitsInStock then
          EventParam.ParamValue:=true;
      end;
    geIsStatusBar:
      begin
        if chStockLevelStatusBar.Checked and (EventParam.Field = DMData.qProductsStockLevel) then
          EventParam.ParamValue:=true;
      end;
    geIsDataImage:
      begin
        if chStockLevelDataImage.Checked and (EventParam.Field = DMData.qProductsStockLevel) then
          EventParam.ParamValue:=true;
      end;
    geIsFixedColumn:
      ;
    geIsReadOnlyColumn:
      ;
    geGetTitleImageIndex:
      ;
    geShowMemoDialog:
      ;
    geShowGraphicDialog:
      ;
    geSetColumnWidth:
      ;
    geContextPopup:
      ;
    geContextTitlePopup:
      ;
    geGetDataBarParam:
      begin
        if EventParam.Field = DMData.qProductsUnitPrice then
          EventParam.ParamValue:=gr.Fields_SetDataBarSettings('', 0, 100, dbtValue);
        if EventParam.Field = DMData.qProductsUnitsInStock then
        begin
          if chUnitsRedColor.Checked and (DMData.qProductsUnitsInStock.AsInteger <= eUnitsLimit.AsInteger) then
            EventParam.ParamValue:=gr.Fields_SetDataBarSettings('', 0, eUnitsLimit.AsInteger*2, dbtValue, clRed, ClWhite)
          else
            EventParam.ParamValue:=gr.Fields_SetDataBarSettings('', 0, 100, dbtValue);
        end;
      end;
    geGetStatusBarParam:
      begin
        if chStockLevelStatusBar.Checked and (EventParam.Field = DMData.qProductsStockLevel) then
        begin
          if DMData.qProductsStockLevel.AsString = 'Low' then
          begin
            EventParam.ParamValue:=gr.Fields_SetStatusBarSettings('', 3, sbtProgressBar, clSilver, clRed);
            EventParam.FieldValue:=1;
          end;
          if DMData.qProductsStockLevel.AsString = 'Mid' then
          begin
            EventParam.ParamValue:=gr.Fields_SetStatusBarSettings('', 3, sbtProgressBar, clSilver, clMaroon);
            EventParam.FieldValue:=2;
          end;
          if DMData.qProductsStockLevel.AsString = 'High' then
          begin
            EventParam.ParamValue:=gr.Fields_SetStatusBarSettings('', 3, sbtProgressBar, clSilver, clGreen);
            EventParam.FieldValue:=3;
          end;
        end;
      end;
    geGetFooterRowParam:
      begin
        if EventParam.Field = DMData.qProductsUnitsOnOrder then
        begin
          if gr.SummaryResults(EventParam.Field, false).Sum < 500 then
            EventParam.ParamValue:=gr.FooterRow_SetSettings('', '%SUM', tadDefault, [fsdBold], clRed, 0);
        end;
      end;
    geGetDataImageIndex:
      begin
        if chStockLevelDataImage.Checked and (EventParam.Field = DMData.qProductsStockLevel) then
        begin
          if DMData.qProductsDiscontinued.AsBoolean then
            EventParam.ParamValue:=-1
          else
          begin
            if DMData.qProductsStockLevel.AsString = 'Low' then
              EventParam.ParamValue:=5;
            if DMData.qProductsStockLevel.AsString = 'Mid' then
              EventParam.ParamValue:=6;
            if DMData.qProductsStockLevel.AsString = 'High' then
              EventParam.ParamValue:=7;
          end;
        end;
      end;
    geGetDataImageAlignment:
      if chStockLevelDataImage.Checked and (EventParam.Field = DMData.qProductsStockLevel) then
      begin
        EventParam.ParamValue:='R';
      end;
  end;

end;

end.
