unit dm_data;

interface

uses
  SysUtils, Classes, Dialogs, Controls, DB, ADODB;

type
  TDMData = class(TDataModule)
    ADOCon: TADOConnection;
    tCustomers: TADOTable;
    tEmployees: TADOTable;
    tCustomersPhone: TStringField;
    tCustomersFAX: TStringField;
    dsEmployees: TDataSource;
    dsCustomers: TDataSource;
    tCustomersPriority: TWideStringField;
    tEmployeesEmployeeID: TAutoIncField;
    tEmployeesLastName: TWideStringField;
    tEmployeesFirstName: TWideStringField;
    tEmployeesBirthDate: TDateTimeField;
    tEmployeesHireDate: TDateTimeField;
    tEmployeesAddress: TWideStringField;
    tEmployeesCity: TWideStringField;
    tEmployeesCountry: TWideStringField;
    tEmployeesHomePhone: TWideStringField;
    tEmployeesExtension: TWideStringField;
    tEmployeesPhoto: TBlobField;
    tEmployeesNotes: TMemoField;
    tEmployeesMale: TBooleanField;
    tEmployeesRole: TWideStringField;
    tEmployeesTitle: TWideStringField;
    tEmployeesEmail: TWideStringField;
    tCustomersCustomerID: TFloatField;
    tCustomersAddress: TWideStringField;
    tCustomersDiscount: TFloatField;
    tEmployeesSalary: TFloatField;
    tCustomersLocked: TWideStringField;
    tCustomersCustomerName: TWideStringField;
    tCustomersEmail: TWideStringField;
    qTracks: TADOQuery;
    dsTracks: TDataSource;
    qTracksId: TAutoIncField;
    qTracksDate: TDateTimeField;
    qTracksUser: TWideStringField;
    qTracksAction: TWideStringField;
    qTracksTableName: TWideStringField;
    qTracksKeyValue: TWideStringField;
    qTracksChanges: TMemoField;
    qTracksMemo: TMemoField;
    tCustomersCompanyID: TIntegerField;
    qTracksSpecial: TIntegerField;
    procedure ADOConWizOpenTables(Sender: TObject; var Opened: Boolean);
    procedure tEmployeesPostError(DataSet: TDataSet; E: EDatabaseError;
      var Action: TDataAction);
    procedure ADOConAfterDisconnect(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    function OpenTables: boolean;
  end;

var
  DMData: TDMData;

implementation

{$R *.dfm}

uses rstring, rdlg, rtool, rdbtool, f_main, rdbComponents;

procedure TDMData.ADOConAfterDisconnect(Sender: TObject);
begin
  if Assigned(Main) then
    Main.SBar.SimpleText:=sDBFile+'none';
end;

function TDMData.OpenTables: boolean;
begin
  Result:=false;
  try
    tEmployees.Close;
    tCustomers.Close;

    tEmployees.Open;
    tCustomers.Open;

    self.qTracks.Close;
    self.qTracks.Open;

    Result:=true;
  except
    on E: Exception do ShowErr('',E,false);
  end;
end;

procedure TDMData.ADOConWizOpenTables(Sender: TObject; var Opened: Boolean);
begin
  Opened:=OpenTables;
end;

procedure TDMData.tEmployeesPostError(DataSet: TDataSet; E: EDatabaseError;
  var Action: TDataAction);
begin
  ShowErr(sSaveRecordErr,E,false);
  Action:=daAbort;
end;

end.
