unit f_main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, StdCtrls, DBCtrls, Mask, Buttons,
  Grids, DBGrids, rDBGrid, DB, ADODB, DBTrackTool, ExtCtrls,
  rStringGridEd, rDBMemoGrid, rHTMLLabel;

const
  Ver='5.2';
  sDBFile='DB file: ';

type
  TMain = class(TForm)
    PageControl: TPageControl;
    TabSheet1: TTabSheet;
    SBar: TStatusBar;
    rDBGrid2: TrDBGrid;
    DBNavigator1: TDBNavigator;
    TabSheet2: TTabSheet;
    DBNavigator2: TDBNavigator;
    rDBGrid1: TrDBGrid;
    TabSheet3: TTabSheet;
    rDBGrid3: TrDBGrid;
    TrackRecTarget1: TTrackRecTarget;
    TrackRecSourceCustomer: TTrackRecSource;
    TrackRecSourceEmpl: TTrackRecSource;
    rDBMemoGrid1: TrDBMemoGrid;
    rHTMLLabel1: TrHTMLLabel;
    rHTMLLabel2: TrHTMLLabel;
    Panel1: TPanel;
    cbEvents: TComboBox;
    Label1: TLabel;
    cbTables: TComboBox;
    Label2: TLabel;
    chSpecOnly: TCheckBox;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure cbTablesClick(Sender: TObject);
  private
    procedure RefFilter;
  public
  end;

var
  Main: TMain;

implementation

{$R *.dfm}

uses rstring, rdlg, rtool, rdbtool, dm_data;

const
  DefaultDB='data\data2000.mdb';
  ConStr='Provider=Microsoft.Jet.OLEDB.4.0;Data Source=';

procedure TMain.FormCreate(Sender: TObject);
begin
  DMData.ADOCon.Close;
  DMData.ADOCon.ConnectionString:=ConStr+GetAppPath+DefaultDB;
  try
    DMData.ADOCon.Open;
    DMData.OpenTables;
    Main.SBar.SimpleText:=sDBFile+DefaultDB;
  except
    on E: exception do ShowErr(sError,E,true);
  end;
end;

procedure TMain.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  DMData.tCustomers.Close;
  DMData.tEmployees.Close;
  DMData.ADOCon.Close;
end;

procedure TMain.cbTablesClick(Sender: TObject);
begin
  RefFilter;
end;

procedure TMain.FormActivate(Sender: TObject);
begin
  PageControl.ActivePageIndex:=0;
end;

procedure TMain.RefFilter;
var s: string;
    i: integer;
begin
  s:='';
  if cbTables.ItemIndex>0 then
    s:=Format('TableName=''%s''',[cbTables.Items[cbTables.ItemIndex]]);
  if cbEvents.ItemIndex>0 then
  begin
    if s<>'' then s:=s+' AND ';
    i:=cbEvents.ItemIndex;
    if i<4 then s:=s+Format('Action=%d',[i-1])
    else s:=s+'Action>=3';
  end;
  if chSpecOnly.Checked then
  begin
    if s<>'' then s:=s+' AND ';
    s:=s+'Special=1';
  end;
  DMData.qTracks.Filter:=s;
  DMData.qTracks.Filtered:=s<>'';
end;

end.
