unit f_categoriesedit;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, DB, Grids, DBGrids, rDBGrid, rImprovedComps, rDBComponents,
  rDBComponents_UDB, rDBGrid_MS, PropSaveMain, PropSaveGrids;

type
  TCategoriesEdit = class(TForm)
    gbBottom: TrGroupBox;
    rDBMoveButton6: TrDBMoveButton;
    rDBMoveButton5: TrDBMoveButton;
    rDBMoveButton3: TrDBMoveButton;
    rDBMoveButton4: TrDBMoveButton;
    btOk: TrDBMoveButton;
    btBack: TrDBMoveButton;
    grCategories: TrDBGrid_MSUDB;
    PropSaveMain1: TPropSaveMain;
    rDBGridsPropSave1: TrDBGridsPropSave;
    rDBGridSorter_UDB1: TrDBGridSorter_UDB;
    procedure FormShow(Sender: TObject);
    procedure btOkClick(Sender: TObject);
    procedure grCategoriesListDataSetEvent(DataSet: TDataSet; EventType: TDatasetEventType);
  private
    { Private declarations }
    NeedReload: boolean;
  public
    { Public declarations }
  end;

var
  CategoriesEdit: TCategoriesEdit;

function SelectCategory(cb: TrDBLookupComboBoxUDB = nil): boolean;

implementation

uses rstring, rdlg, rtool, rdbtool, dm_data, dm_auxdata;
{$R *.dfm}

function SelectCategory(cb: TrDBLookupComboBoxUDB = nil): boolean;
var
  ListF: TField;
  ds: TDataSet;
  sel: boolean;
begin
  CreateF(TCategoriesEdit, CategoriesEdit);
  ds:=CategoriesEdit.grCategories.ListDataSet;
  if not ds.Active then
    ds.Open;

  // select active record regarding combobox
  ListF:=nil;
  if Assigned(cb) then
  begin
    ListF:=ds.FieldByName(cb.DataField);
    ds.Locate(ListF.FieldName, cb.KeyValue, []);
  end;
  CategoriesEdit.btOk.Visible:=Assigned(cb);

  // show window
  sel:=CategoriesEdit.ShowModal = mrOk;
  Result:=CategoriesEdit.NeedReload;

  // update combobox
  if Assigned(cb) then
  begin
    if Result then
      cb.ReloadItems;
    if sel and (ListF.Value <> cb.KeyValue) then
    begin
      cb.DataSource.DataSet.Edit;
      if IsEditing(cb.DataSource.DataSet) then
        cb.Field.Value:=ListF.Value;
    end;
  end;
end;

procedure TCategoriesEdit.FormShow(Sender: TObject);
begin
  NeedReload:=false;
  // use rGroupBox proc to link all rDBMoveButtons to internal dataset
  AuxData.SetAllChildrenDataSource(gbBottom, self.grCategories.ListDataSource, 1);
end;

procedure TCategoriesEdit.btOkClick(Sender: TObject);
begin
  ModalResult:=mrOk;
end;

procedure TCategoriesEdit.grCategoriesListDataSetEvent(DataSet: TDataSet; EventType: TDatasetEventType);
begin
  case EventType of
    deAfterPost, deAfterDelete:
      NeedReload:=true;
    deBeforeDelete:
      if DlgQ(rstring.sDeleteQ) <> mrYes then
        Abort;
  end;
end;

end.
